import lunr from 'lunr';
import $ from 'jquery';

function search(element) {
    return new Promise(function (resolve, reject) {
        $.get('/documents.json', function (documents) {
            let mappedDocuments = {}
            $.each(documents, function (index, doc) {
                mappedDocuments[doc.url] = doc
            })

            let idx = lunr(function () {
                this.ref('url')
                this.field('title')
                this.field('body')

                let lunridx = this
                $.each(documents, function (index, doc) {
                    lunridx.add(doc)
                })
            })

            resolve({
                element: element,
                idx: idx,
                search(query) {
                    let result = this.idx.search(query)
                    let actualResult = [];

                    $.each(result, (key, value) => {
                        actualResult.push({
                            ref: value.ref,
                            title: mappedDocuments[value.ref].title,
                        })
                    })

                    return actualResult
                }
            })
        })
    })
}

export default search;
